unit Bingo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, DBTables, StdCtrls, Buttons, Spin, ComCtrls;

type
  TfmBingo = class(TForm)
    Label1: TLabel;
    se1: TSpinEdit;
    Label2: TLabel;
    se2: TSpinEdit;
    Label3: TLabel;
    BitBtn1: TBitBtn;
    btnPrint: TBitBtn;
    tbTmp: TTable;
    pb1: TProgressBar;
    lbPaper: TLabel;
    procedure btnPrintClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure se2Change(Sender: TObject);
  private
    { Private declarations }
    TempDir: String;
    procedure CreateTmp;
    procedure OpenTable;
    procedure SetupData;
  public
    { Public declarations }
  end;

var
  fmBingo: TfmBingo;

implementation

uses rpBingo;

{$R *.dfm}

procedure TfmBingo.CreateTmp;
var i: Integer;
begin
  with tbTmp do
  begin
    Active:= false;
    FieldDefs.Clear;
    FieldDefs.Add('S0', ftInteger, 0, false);
    for i:= 1 to 25 do
      FieldDefs.Add('S'+ IntToStr(i), ftSmallint, 0, false);
    CreateTable;
  end;
end;

procedure TfmBingo.OpenTable;
begin
  if not FileExists(TempDir+ '\'+ tbTmp.TableName+ '.db') then CreateTmp;
  tbTmp.Active:= false;
  tbTmp.EmptyTable;
  tbTmp.Active:= true;
end;

procedure TfmBingo.SetupData;
var i, j, k, k1, k2, mx, mb: Integer;
    p: array [1..25] of Integer;
    pass: Boolean;
begin
  pb1.Max:= se2.Value;
  pb1.Position:= 0;
  pb1.Visible:= true;
  mx:= se1.Value;
  k1:= 0;
  mb:= 0;
  for i:= 1 to se2.Value do
  begin
    pb1.Position:= pb1.Position+ 1;
    for j:= 1 to 6 do
    begin
      for k:= 1 to 25 do p[k]:= 0;
      p[1]:= Random(mx)+ 1;
      for k:= 2 to 25 do
      begin
        pass:= true;
        while pass do
        begin
          pass:= false;
          k1:= Random(mx)+ 1;
          for k2:= 1 to k-1 do
            if k1=p[k2] then
            begin
              pass:= true;
              break;
            end;
        end;
        p[k]:= k1;
      end;
      mb:= mb+ 1;
      tbTmp.Append;
      tbTmp.FieldByName('S0').asInteger:= mb;
      for k:= 1 to 25 do
        tbTmp.FieldByName('S'+ IntToStr(k)).asInteger:= p[k];
      tbTmp.Post;
    end;
  end;
  pb1.Visible:= false;
end;

procedure TfmBingo.btnPrintClick(Sender: TObject);
begin
  OpenTable;
  SetupData;
  rpBingo.QR1.Preview;
end;

procedure TfmBingo.FormCreate(Sender: TObject);
begin
  Randomize;
  TempDir:= GetEnvironmentVariable('TEMP');
  tbTmp.DatabaseName:= TempDir;
  tbTmp.TableName:= 'tmpBingo';
end;

procedure TfmBingo.se2Change(Sender: TObject);
begin
  lbPaper.Caption:= '@'+ IntToStr(se2.Value*6)+ 'im';
end;

end.
